// C Header File
// Created 26/06/03; 14:26:28

// compile for ti92+/v200 or ti89
#define USE_TI89              // Compile for TI-89
#define USE_TI92PLUS          // Compile for TI-92 Plus
#define USE_V200              // Compile for V200

#define OPTIMIZE_ROM_CALLS    // Use ROM Call Optimization
#define MIN_AMS 100           // Compile for AMS 1.00 or higher
#define NO_AMS_CHECK          // Compile for any AMS version
#define SAVE_SCREEN           // Save/Restore LCD Contents
#define NO_EXIT_SUPPORT

#include <tigcclib.h>         // Include All Header Files

// Macros: on-calc compatibility
#define Xmax (CALCULATOR?239:159)
#define Ymax (CALCULATOR?127:99)
#define wait_no_key() while(getkey(CALCULATOR));
#define wait_a_key() while(!getkey(CALCULATOR));

// Macros: keys tests
#define K_ENTER (g & 0x0020)
#define K_ESC   (g & 0x0010)
#define K_UP    (g & 0x0001)
#define K_DOWN  (g & 0x0002)
#define K_RIGHT (g & 0x0004)
#define K_LEFT  (g & 0x0008)

// Sprites
#define spriteBD 0x7
#define spriteBG 0x8
#define spriteHD 0x9
#define spriteHG 0xA

// enums
enum e_MASKS  {COLOR_MASK=7,P1_MASK=8,P2_MASK=16,DATA_MASK=31,TEST_MASK=32,FILL_MASK=64};
enum e_COORDS {PLAYER1_X,PLAYER1_Y,PLAYER2_X,PLAYER2_Y};
enum e_TYPE   {PLAYER_VS_AI=1,PLAYER_VS_PLAYER=2};
enum e_PLAYER {PLAYER1,PLAYER2};
enum e_MENU   {FRAG,SIZE,TYPE};
  
// vars
extern unsigned short total[2];
extern unsigned char table[22][21];
extern unsigned char player_color[2];
extern unsigned char player;
extern unsigned char color;

extern unsigned char fragmentation;
extern unsigned char TABLE_WIDTH;
extern unsigned char TABLE_HEIGHT;
extern unsigned char game_type;

// C funcs
short game_menu(void);
short main_menu(void);
short winner_check(void);
void draw_table(const short X,const short Y);
void fill_table(void);
void expand(void);
void AI_do();

// Asm functions
short getkey(short calc);
void Sprite16x16x4_or(register short x asm("%d0"),register short y asm("%d1"),register short nbr asm("%d2"),register void *dest0 asm("%a0"),register void *dest1 asm("%a1"));

